## yubico-piv-tool 1.0.1

=== debian/changelog ===
yubico-piv-tool (1.0.1-1) unstable; urgency=low

  * New upstream version.
    - Update debian/copyright to match GPL->BSD relicense.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 11 Aug 2015 14:02:39 +0200

yubico-piv-tool (1.0.0-1) unstable; urgency=low

  * New upstream version.
  * Update README.source.
  * Add gbp.conf.
  * Add Alessio as uploader, and update upstream-signing-key.pgp.
  * Update symbols.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 07 Jul 2015 22:47:03 +0200

yubico-piv-tool (0.1.6-1) unstable; urgency=low

  * New upstream version.

 -- Simon Josefsson <simon@josefsson.org>  Wed, 15 Apr 2015 14:53:54 +0200

yubico-piv-tool (0.1.5-1) unstable; urgency=low

  * Initial release. (Closes: #779837)

 -- Hans-Christoph Steiner <hans@eds.org>  Mon, 30 Mar 2015 16:53:01 -0400

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.sig/ \
  https://developers.yubico.com/yubico-piv-tool/Releases yubico-piv-tool-(.*)\.tar\.gz

## yubico-piv-tool 2.2.0

=== CMakeLists.txt ===
# Copyright (c) 2020 Yubico AB
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required (VERSION 3.5)
cmake_policy(SET CMP0025 NEW)
include(CheckFunctionExists)
set (CMAKE_C_STANDARD 99)

project (yubico-piv-tool)

set (yubico_piv_tool_VERSION_MAJOR 2)
set (yubico_piv_tool_VERSION_MINOR 2)
set (yubico_piv_tool_VERSION_PATCH 0)
set (VERSION "${yubico_piv_tool_VERSION_MAJOR}.${yubico_piv_tool_VERSION_MINOR}.${yubico_piv_tool_VERSION_PATCH}")
set (SO_VERSION 2)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")
include(${CMAKE_SOURCE_DIR}/cmake/options.cmake)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug)
endif()

include(CheckCCompilerFlag)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

if(WIN32)
    add_definitions(-DWIN32_LEAN_AND_MEAN)
    set(_WIN32 ${WIN32})
endif()

if(MSVC)
    if((NOT GETOPT_LIB_DIR) OR (NOT GETOPT_INCLUDE_DIR))
        message(FATAL_ERROR "please provide definitions for "
                "GETOPT_LIB_DIR and GETOPT_INCLUDE_DIR when building "
                "under msvc")
    endif()
    if(SUPRESS_MSVC_WARNINGS)
        set(MSVC_DISABLED_WARNINGS_LIST
            "C4200" # nonstandard extension used: zero-sized array in struct/union;
            "C4204" # nonstandard extension used: non-constant aggregate initializer;
            "C4706" # assignment within conditional expression;
            "C4996" # The POSIX name for this item is deprecated. Instead, use the ISO C and C++ conformant name

            "C4473" # Not enough arguments passed for format string placeholders
            "C4244" # Conversion from 'int' to 'unsigned char', possible loss of data
            "C4152" # Nonstandard extension, function/data pointer conversion in expression (openssl/applink.c)
            "C4068" # Unknown pragma
            "C4701" # Potentially uninitialized local variable
            "C4703" # Potentially uninitialized local pointer
            "C4100" # 'param': unreferenced formal parameter (unsupported pkcs11 functions)
            "C4221" # Nonstandard extension used: 'pValue': cannot be initialized using address of automatic variable (ykcs11_tests_util)
            "C4057" # 'const char *' differs in indirection to slightly different base types from 'const CK_CHAR_PTR' (ykcs11 tests)
            "C4245" # Conversion from 'int' to 'CK_ULONG' (ykcs11 tests)
            "C4013" # '_getpid' undefined; assuming extern returning int (ykcs11/utils.c)
            "C4702" # Unreachable code (mechanisms.c:is_RSA_mechanism)
            "C4133" # Incompatible types: from 'ykpiv_rc' (enum) to 'int'
            "C4267" # Conversion from 'size_t' to 'CK_ULONG'
            "C4312" # Conversion from 'unsigned int' to 'void *' of greater size (ykcs11/utils.c:noop_create_mutex)
            )
        # The construction in the following 3 lines was taken from LibreSSL's
        # CMakeLists.txt.
        string(REPLACE "C" " -wd" MSVC_DISABLED_WARNINGS_STR ${MSVC_DISABLED_WARNINGS_LIST})
        string(REGEX REPLACE "[/-]W[1234][ ]?" "" CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -MP -W4 ${MSVC_DISABLED_WARNINGS_STR}")
    endif(SUPRESS_MSVC_WARNINGS)

    set(BUILD_SHARED_LIBS ON)
    set(GENERATE_MAN_PAGES OFF)
    set(LIBCRYPTO_LIBRARIES ${LIBCRYPTO_LIBRARIES} bcrypt)
else()
    find_package (PkgConfig REQUIRED)

    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -w") # -g -O2
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wextra -Werror")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wwrite-strings")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-prototypes")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wbad-function-cast")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pedantic")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fstack-protector-all")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")

    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -g2")
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fno-omit-frame-pointer")
endif()

# Use -Wshorten-64-to-32 if available.
check_c_compiler_flag("-Wshorten-64-to-32" HAVE_SHORTEN_64_TO_32)
if(HAVE_SHORTEN_64_TO_32)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshorten-64-to-32")
endif()

# Avoid https://gcc.gnu.org/bugzilla/show_bug.cgi?id=66425
if(CMAKE_COMPILER_IS_GNUCC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-result")
endif()

include(${CMAKE_SOURCE_DIR}/cmake/openssl.cmake)
find_libcrypto()
include_directories(${LIBCRYPTO_INCLUDE_DIRS})

enable_testing()
find_package(codecov)

# explicit_bzero
check_function_exists(explicit_bzero HAVE_EXPLICIT_BZERO)
if(HAVE_EXPLICIT_BZERO)
	add_definitions(-DHAVE_EXPLICIT_BZERO)
endif()

add_subdirectory (lib)
if(NOT BUILD_ONLY_LIB)
    add_subdirectory(ykcs11)
    add_subdirectory(tool)
endif()

coverage_evaluate()

message("Build summary:")
message("")
message("        Project name:     ${CMAKE_PROJECT_NAME}")
message("        Version:          ${VERSION}")
message("        Host type:        ${CMAKE_SYSTEM_NAME}")
message("        Install prefix:   ${CMAKE_PREFIX_PATH}")
message("        Compiler:         ${CMAKE_C_COMPILER}")
message("        Compiler ID:      ${CMAKE_C_COMPILER_ID}")
message("        CFLAGS:           ${CMAKE_C_FLAGS}")
message("        CPPFLAGS:         ${CMAKE_CXX_FLAGS}")
message("        Warnings:         ${WARN_FLAGS}")
message("        Build type:       ${CMAKE_BUILD_TYPE}")
message("        Backend:          ${BACKEND}")
message("        PCSC")
message("                CFLAGS:   ${PCSC_CFLAGS}")
message("                LIBS:     ${PCSC_LIBRARIES}")
message("        Winscard")
message("                LIBS:     ${PCSC_WIN_LIBS}")
message("        Mac PCSC")
message("                LIBS:     ${PCSC_MACOSX_LIBS}")
message("        Custom PCSC")
message("                LIBS:     ${PCSC_CUSTOM_LIBS}")
message("")
message("        Install prefix:    ${CMAKE_INSTALL_PREFIX}")
message("        Install targets")
message("                Libraries  ${YKPIV_INSTALL_LIB_DIR}")
message("                Includes   ${YKPIV_INSTALL_INC_DIR}")
message("                Binaries   ${YKPIV_INSTALL_BIN_DIR}")
message("                Manuals    ${YKPIV_INSTALL_MAN_DIR}")
message("                Pkg-config ${YKPIV_INSTALL_PKGCONFIG_DIR}")
message("")
message("        YKCS11 debug:     ${ENABLE_YKCS11_DBG}")
if(ENABLE_HARDWARE_TESTS)
    message("        Hardware tests:   Enabled. *** WARNING: RUNNING THE TESTS WILL ERASE ALL DATA ON CONNECTED YUBIKEYS *** ")
else(ENABLE_HARDWARE_TESTS)
    message("        Hardware tests:   Disabled")
endif(ENABLE_HARDWARE_TESTS)

=== lib/CMakeLists.txt ===
# Copyright (c) 2020 Yubico AB
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

message("lib/CMakeList.txt")

include(${CMAKE_SOURCE_DIR}/cmake/pcscd.cmake)
find_pcscd()

set(YKPIV_VERSION_STRING "${yubico_piv_tool_VERSION_MAJOR}.${yubico_piv_tool_VERSION_MINOR}.${yubico_piv_tool_VERSION_PATCH}")

set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)

set(SOURCE
        ykpiv.c
        util.c
        version.c
        error.c
        internal.c
        ../common/openssl-compat.c
        ../common/util.c)

include_directories(
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${CMAKE_SOURCE_DIR}/common
)

# static library
if(BUILD_STATIC_LIB)
    add_library(ykpiv STATIC ${SOURCE})
    target_link_libraries(ykpiv ${LIBCRYPTO_LIBRARIES} ${PCSC_LIBRARIES} ${PCSC_WIN_LIBS} ${PCSC_MACOSX_LIBS} ${PCSC_CUSTOM_LIBS})
    set_target_properties (ykpiv PROPERTIES COMPILE_FLAGS "-DSTATIC ")
    if(WIN32)
        set_target_properties(ykpiv PROPERTIES OUTPUT_NAME ykpiv_static)
    endif()
    add_coverage(ykpiv)
endif(BUILD_STATIC_LIB)

# dynamic library
add_library(ykpiv_shared SHARED ${SOURCE})
target_link_libraries(ykpiv_shared ${LIBCRYPTO_LIBRARIES} ${PCSC_LIBRARIES} ${PCSC_WIN_LIBS} ${PCSC_MACOSX_LIBS} ${PCSC_CUSTOM_LIBS})
set_target_properties(ykpiv_shared PROPERTIES SOVERSION ${SO_VERSION} VERSION ${VERSION})
set_target_properties(ykpiv_shared PROPERTIES INSTALL_RPATH "${YKPIV_INSTALL_LIB_DIR}")
if(WIN32)
    set_target_properties(ykpiv_shared PROPERTIES OUTPUT_NAME libykpiv)
else(WIN32)
    set_target_properties(ykpiv_shared PROPERTIES OUTPUT_NAME ykpiv)
endif(WIN32)
add_coverage(ykpiv_shared)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ykpiv.pc.in ${CMAKE_CURRENT_SOURCE_DIR}/ykpiv.pc @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ykpiv-config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/ykpiv-config.h @ONLY)

install(
        TARGETS ykpiv_shared
        ARCHIVE DESTINATION ${YKPIV_INSTALL_LIB_DIR}
        LIBRARY DESTINATION ${YKPIV_INSTALL_LIB_DIR}
        RUNTIME DESTINATION ${YKPIV_INSTALL_BIN_DIR})
if(BUILD_STATIC_LIB)
    install(
        TARGETS ykpiv
        ARCHIVE DESTINATION ${YKPIV_INSTALL_LIB_DIR}
        LIBRARY DESTINATION ${YKPIV_INSTALL_LIB_DIR}
        RUNTIME DESTINATION ${YKPIV_INSTALL_BIN_DIR})
endif(BUILD_STATIC_LIB)

install(FILES ykpiv.h DESTINATION ${YKPIV_INSTALL_INC_DIR}/ykpiv)
install(FILES ykpiv-config.h DESTINATION ${YKPIV_INSTALL_INC_DIR}/ykpiv)

install(FILES ykpiv.pc DESTINATION ${YKPIV_INSTALL_PKGCONFIG_DIR})

add_subdirectory(tests)

=== tool/CMakeLists.txt ===
# Copyright (c) 2020 Yubico AB
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

message("tool/CMakeList.txt")

set (SOURCE
        yubico-piv-tool.c
        ../common/openssl-compat.c
        ../common/util.c)

if(WIN32)
    add_definitions (-DPACKAGE="yubico-piv-tool")
    add_definitions (-DVERSION="${yubico_piv_tool_VERSION_MAJOR}.${yubico_piv_tool_VERSION_MINOR}.${yubico_piv_tool_VERSION_PATCH}")

    set(SOURCE ${SOURCE} cmdline.c)

    find_library(GETOPT getopt PATHS ${GETOPT_LIB_DIR})
    set(LINK_LIBS_WIN ${GETOPT})
    include_directories(${GETOPT_INCLUDE_DIR})
else(WIN32)
    include(${CMAKE_SOURCE_DIR}/cmake/gengetopt.cmake)
    find_gengetopt()
    add_gengetopt_files(cmdline)
    set(SOURCE ${SOURCE} ${GGO_C})
endif(WIN32)

include_directories (
        ${CMAKE_SOURCE_DIR}/lib
        ${CMAKE_CURRENT_SOURCE_DIR}
)

add_executable (yubico-piv-tool ${SOURCE})
target_link_libraries(yubico-piv-tool ${LIBCRYPTO_LDFLAGS} ${LINK_LIBS_WIN} ykpiv_shared)
add_coverage(yubico-piv-tool)

set_target_properties(yubico-piv-tool PROPERTIES INSTALL_RPATH "${YKPIV_INSTALL_LIB_DIR}")
install(
        TARGETS yubico-piv-tool
        ARCHIVE DESTINATION "${YKPIV_INSTALL_LIB_DIR}"
        LIBRARY DESTINATION "${YKPIV_INSTALL_LIB_DIR}"
        RUNTIME DESTINATION "${YKPIV_INSTALL_BIN_DIR}")

if (GENERATE_MAN_PAGES)
    include (${CMAKE_SOURCE_DIR}/cmake/help2man.cmake)
    add_help2man_manpage (yubico-piv-tool.1 yubico-piv-tool)

    add_custom_target (yubico-piv-tool-man ALL DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/yubico-piv-tool.1)
    install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/yubico-piv-tool.1" DESTINATION "${YKPIV_INSTALL_MAN_DIR}/man1")
endif(GENERATE_MAN_PAGES)

# If somehow a manpage was generated before configure started, install that too
find_file(MAN_PAGE yubico-piv-tool.1 PATHS ${CMAKE_CURRENT_SOURCE_DIR})
if(MAN_PAGE)
    install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/yubico-piv-tool.1" DESTINATION "${YKPIV_INSTALL_MAN_DIR}/man1")
endif(MAN_PAGE)

add_subdirectory(tests)

=== ykcs11/CMakeLists.txt ===
# Copyright (c) 2020 Yubico AB
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

message("ykcs11/CMakeList.txt")

link_directories(${PCSC_LIBRARY_DIRS})
add_definitions(-DCRYPTOKI_EXPORTS)
if(NOT WIN32)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
endif(NOT WIN32)

set(
        SOURCE
        ykcs11.c
        token.c
        mechanisms.c
        utils.c
        openssl_utils.c
        objects.c
        ../common/openssl-compat.c
        ../common/util.c
)

include_directories(
        ${CMAKE_SOURCE_DIR}/lib
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${LIBCRYPTO_INCLUDE_DIRS}
)

set(YKCS11_VERSION_MAJOR ${yubico_piv_tool_VERSION_MAJOR})
set(YKCS11_VERSION_MINOR  ${yubico_piv_tool_VERSION_MINOR})
set(YKCS11_VERSION_PATCH ${yubico_piv_tool_VERSION_PATCH})
set(YKCS11_VERSION_STRING "${YKCS11_VERSION_MAJOR}.${YKCS11_VERSION_MINOR}.${YKCS11_VERSION_PATCH}")
set(YKCS11_VERSION_NUMBER ${YKCS11_VERSION_MAJOR}.${YKCS11_VERSION_MINOR}.${YKCS11_VERSION_PATCH})
if(${ENABLE_HARDWARE_TESTS})
    set(HW_TESTS 1)
endif(${ENABLE_HARDWARE_TESTS})

# static library
if(BUILD_STATIC_LIB)
    add_library(ykcs11 STATIC ${SOURCE})
    target_link_libraries(ykcs11 ${LIBCRYPTO_LDFLAGS} ykpiv_static)
    set_target_properties (ykcs11 PROPERTIES COMPILE_FLAGS "-DSTATIC ")
    if(WIN32)
        set_target_properties(ykcs11 PROPERTIES OUTPUT_NAME ykcs11_static)
    endif()
    add_coverage(ykcs11)
endif(BUILD_STATIC_LIB)

# dynamic library
add_library(ykcs11_shared SHARED ${SOURCE})
target_link_libraries(ykcs11_shared ${LIBCRYPTO_LDFLAGS} ykpiv_shared)
set_target_properties(ykcs11_shared PROPERTIES SOVERSION ${SO_VERSION} VERSION ${VERSION})
set_target_properties(ykcs11_shared PROPERTIES INSTALL_RPATH "${YKPIV_INSTALL_LIB_DIR}")
if(WIN32)
    set_target_properties(ykcs11_shared PROPERTIES OUTPUT_NAME libykcs11)
else(WIN32)
    set_target_properties(ykcs11_shared PROPERTIES OUTPUT_NAME ykcs11)
endif(WIN32)
add_coverage(ykcs11_shared)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ykcs11.pc.in ${CMAKE_CURRENT_SOURCE_DIR}/ykcs11.pc @ONLY)
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/ykcs11-config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/ykcs11-config.h @ONLY)

install(
        TARGETS ykcs11_shared
        ARCHIVE DESTINATION "${YKPIV_INSTALL_LIB_DIR}"
        LIBRARY DESTINATION "${YKPIV_INSTALL_LIB_DIR}"
        RUNTIME DESTINATION "${YKPIV_INSTALL_BIN_DIR}")

if(BUILD_STATIC_LIB)
    install(
        TARGETS ykcs11
        ARCHIVE DESTINATION "${YKPIV_INSTALL_LIB_DIR}"
        LIBRARY DESTINATION "${YKPIV_INSTALL_LIB_DIR}"
        RUNTIME DESTINATION "${YKPIV_INSTALL_BIN_DIR}")
endif(BUILD_STATIC_LIB)

install(FILES ykcs11.pc DESTINATION ${YKPIV_INSTALL_PKGCONFIG_DIR})

add_subdirectory(tests)

=== lib/tests/CMakeLists.txt ===
# Copyright (c) 2020 Yubico AB
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#   * Redistributions of source code must retain the above copyright
#     notice, this list of conditions and the following disclaimer.
#
#   * Redistributions in binary form must reproduce the above
#     copyright notice, this list of conditions and the following
#     disclaimer in the documentation and/or other materials provided
#     with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

message("lib/tests/CMakeList.txt")

if(CMAKE_C_COMPILER_ID MATCHES Clang)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIE")
elseif(NOT MSVC)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIE -pie")
endif()

include(check)
find_check()

if(NOT DEFINED SKIP_TESTS)
    set(SOURCE_BASIC basic.c)
    set(SOURCE_API api.c)
    set(SOURCE_PARSE_KEY parse_key.c)

    add_executable (test_basic ${SOURCE_BASIC})
    add_executable(test_api ${SOURCE_API})
    add_executable(test_parse_key ${SOURCE_PARSE_KEY})

    target_link_libraries(test_basic ykpiv_shared ${LIBCRYPTO_LDFLAGS} ${LIBCHECK_LDFLAGS})
    target_link_libraries(test_api ykpiv_shared ${LIBCRYPTO_LDFLAGS} ${LIBCHECK_LDFLAGS})
    target_link_libraries(test_parse_key ykpiv_shared ${LIBCRYPTO_LDFLAGS} ${LIBCHECK_LDFLAGS})

    if(${ENABLE_HARDWARE_TESTS})
        set(HW_TESTS 1)
    endif(${ENABLE_HARDWARE_TESTS})

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/test-config.h.in ${CMAKE_CURRENT_SOURCE_DIR}/test-config.h @ONLY)

    add_test(
        NAME basic
        COMMAND test_basic
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lib/tests/
    )

    add_test(
        NAME api
        COMMAND test_api
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lib/tests/
    )
    set_property(TEST api APPEND PROPERTY ENVIRONMENT "YKPIV_ENV_HWTESTS_CONFIRMED=${HW_TESTS}")

    add_test(
        NAME parse_key
        COMMAND test_parse_key
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/lib/tests/
    )
endif(NOT DEFINED SKIP_TESTS)

=== ykcs11/tests/CMakeLists.txt ===
# Copyright (c) 2020 Yubico AB
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

message("ykcs11/tests/CMakeList.txt")

include(check)
find_check()

if(NOT DEFINED SKIP_TESTS)
    if(ENABLE_HARDWARE_TESTS)
        if(NOT WIN32)
            add_test(
                NAME reset_tests
                COMMAND ${BASH_PROGRAM} ${CMAKE_CURRENT_SOURCE_DIR}/reset.sh
            )
            set_property(TEST reset_tests APPEND PROPERTY ENVIRONMENT "EXEEXT=${CMAKE_EXECUTABLE_SUFFIX}")
            set_property(TEST reset_tests APPEND PROPERTY ENVIRONMENT "YKPIV_ENV_HWTESTS_CONFIRMED=${HW_TESTS}")
        else(NOT WIN32)
            message("Running on Windows. Skipping basic tests...")
        endif(NOT WIN32)
    endif(ENABLE_HARDWARE_TESTS)

    set(SOURCE_YKCS11_TESTS
            ykcs11_tests.c
            ykcs11_tests_util.c
    )

    add_executable(test_ykcs11 ${SOURCE_YKCS11_TESTS})
    target_link_libraries(test_ykcs11 ykcs11_shared ${LIBCRYPTO_LDFLAGS})

    add_test(
        NAME test_ykcs11
        COMMAND test_ykcs11
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/ykcs11/tests/
    )
    set_property(TEST test_ykcs11 APPEND PROPERTY ENVIRONMENT "YKPIV_ENV_HWTESTS_CONFIRMED=${HW_TESTS}")
endif(NOT DEFINED SKIP_TESTS)

## yubico-piv-tool 1.0.3

=== debian/changelog ===
yubico-piv-tool (1.0.3-1) unstable; urgency=low

  * New upstream version.

 -- Simon Josefsson <simon@josefsson.org>  Thu, 08 Oct 2015 12:37:17 +0200

yubico-piv-tool (1.0.2-1) unstable; urgency=low

  * New upstream version.
  * Update upstream-signing-key.pgp.
  * Tweak watch file.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 22 Sep 2015 08:31:55 +0200

=== debian/control ===
Source: yubico-piv-tool
Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
Uploaders: Simon Josefsson <simon@josefsson.org>, Klas Lindfors <klas@yubico.com>, Dain Nilsson <dain@yubico.com>, Alessio Di Mauro <alessio@yubico.com>
Section: utils
Priority: extra
Build-Depends: debhelper (>= 9), pkg-config, libpcsclite-dev, libssl-dev, gengetopt, help2man, dh-autoreconf, chrpath
Standards-Version: 3.9.6
Homepage: https://developers.yubico.com/yubico-piv-tool/
Vcs-Git: git://github.com/Yubico/yubico-piv-tool-dpkg.git
Vcs-Browser: https://github.com/Yubico/yubico-piv-tool-dpkg

Package: libykpiv1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: pcscd
Description: Library for communication with the YubiKey NEO PIV applet
 The Yubico PIV tool is used for interacting with the Privilege and
 Identification Card (PIV) applet on a YubiKey NEO. With it you may
 generate keys on the device, importing keys and certificates, and
 create certificate requests, and other operations.  A shared library
 and a command-line tool is included.
 .
 This package contains the run-time shared library.  You normally don't
 need to install it manually.

Package: libykpiv-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, libykpiv1 (= ${binary:Version})
Description: Development files for the YubiKey NEO PIV applet library
 The Yubico PIV tool is used for interacting with the Privilege and
 Identification Card (PIV) applet on a YubiKey NEO. With it you may
 generate keys on the device, importing keys and certificates, and
 create certificate requests, and other operations.  A shared library
 and a command-line tool is included.
 .
 This package contains the development files for the library.

Package: yubico-piv-tool
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Command line tool for the YubiKey NEO PIV applet
 The Yubico PIV tool is used for interacting with the Privilege and
 Identification Card (PIV) applet on a YubiKey NEO. With it you may
 generate keys on the device, importing keys and certificates, and
 create certificate requests, and other operations.  A shared library
 and a command-line tool is included.
 .
 This package contains the command-line tool.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --parallel --with autoreconf --builddirectory=build

override_dh_install:
	chrpath -d $(CURDIR)/debian/tmp/usr/bin/*
	chrpath -d $(CURDIR)/debian/tmp/usr/lib/*/libykpiv.so.*
	find debian/tmp -name \*.la -delete
	dh_install --fail-missing

override_dh_auto_configure:
	dh_auto_configure -- --disable-silent-rules

## yubico-piv-tool 1.4.2

=== debian/changelog ===
yubico-piv-tool (1.4.2-2ubuntu0.1) bionic-security; urgency=medium

  * SECURITY UPDATE: Improper bounds checking leading to buffer overflow and
    out-of-bounds read
    - debian/patches/CVE-2018-14779: in ykpiv_transfer_data() handle overflow
      by exiting
    - debian/patches/CVE-2018-14780: in ykpiv_fetch_object() handle bogus
      length by returning
    - CVE-2018-14779
    - CVE-2018-14780

 -- Mike Salvatore <mike.salvatore@canonical.com>  Thu, 06 Feb 2020 17:13:56 -0500

yubico-piv-tool (1.4.2-2) unstable; urgency=medium

  * Fix openssl 1.1 ftbfs.  Closes: #828616.

 -- Simon Josefsson <simon@josefsson.org>  Sun, 08 Jan 2017 12:41:03 +0100

yubico-piv-tool (1.4.2-1) unstable; urgency=medium

  * New upstream version.
  * Clarify debian/copyright wrt ykcs11/pkcs11.h.

 -- Simon Josefsson <simon@josefsson.org>  Sun, 14 Aug 2016 22:28:46 +0200

yubico-piv-tool (1.4.1-1) unstable; urgency=medium

  * New upstream version.

 -- Simon Josefsson <simon@josefsson.org>  Fri, 12 Aug 2016 13:57:11 +0200

yubico-piv-tool (1.4.0-1) unstable; urgency=medium

  [ Simon Josefsson ]
  * Use https URLs in Vcs-Git.
  * Update Standards-Version from 3.9.6 to 3.9.8.
  * Build with hardening=+all.
  * Improve package descriptions (lintian duplicate-short-description).

  [ Klas Lindfors ]
  * New upstream version.  Closes: #810284.

 -- Simon Josefsson <simon@josefsson.org>  Thu, 04 Aug 2016 12:05:28 +0200

yubico-piv-tool (1.1.2-1) unstable; urgency=low

  * New upstram version.

 -- Alessio Di Mauro <alessio@yubico.com>  Fri, 13 Nov 2015 16:16:09 +0100

yubico-piv-tool (1.1.1-1) unstable; urgency=low

  * New upstream version.

 -- Alessio Di Mauro <alessio@yubico.com>  Wed, 11 Nov 2015 18:58:58 +0100

yubico-piv-tool (1.1.0-1) unstable; urgency=low

  * New upstream version.

 -- Alessio Di Mauro <alessio@yubico.com>  Mon, 09 Nov 2015 09:30:26 +0100

=== debian/control ===
Source: yubico-piv-tool
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
Uploaders: Simon Josefsson <simon@josefsson.org>, Klas Lindfors <klas@yubico.com>, Dain Nilsson <dain@yubico.com>, Alessio Di Mauro <alessio@yubico.com>
Section: utils
Priority: extra
Build-Depends: debhelper (>= 9), pkg-config, libpcsclite-dev, libssl1.0-dev | libssl-dev (<< 1.1.0~), gengetopt, help2man, dh-autoreconf, chrpath
Standards-Version: 3.9.8
Homepage: https://developers.yubico.com/yubico-piv-tool/
Vcs-Browser: https://github.com/Yubico/yubico-piv-tool-dpkg
Vcs-Git: https://github.com/Yubico/yubico-piv-tool-dpkg.git

Package: libykpiv1
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: pcscd
Replaces: libykpiv0
Conflicts: libykpiv0
Description: Library for communication with the YubiKey PIV smartcard
 The Yubico PIV tool is used for interacting with the Personal
 Identity Verification Card (PIV) application on a YubiKey.  With it
 you may generate keys on the device, import keys and certificates,
 create certificate requests, and other operations. A shared library,
 a PKCS#11 module a command-line tool are included.
 .
 This package contains the run-time shared library.  You normally don't
 need to install it manually.

Package: libykpiv-dev
Architecture: any
Section: libdevel
Depends: ${shlibs:Depends}, ${misc:Depends}, libykpiv1 (= ${binary:Version})
Description: Development files for the YubiKey PIV Library
 The Yubico PIV tool is used for interacting with the Personal
 Identity Verification Card (PIV) application on a YubiKey.  With it
 you may generate keys on the device, import keys and certificates,
 create certificate requests, and other operations. A shared library,
 a PKCS#11 module a command-line tool are included.
 .
 This package contains the development files for the library.

Package: yubico-piv-tool
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Command line tool for the YubiKey PIV applet
 The Yubico PIV tool is used for interacting with the Personal
 Identity Verification Card (PIV) application on a YubiKey.  With it
 you may generate keys on the device, import keys and certificates,
 create certificate requests, and other operations. A shared library,
 a PKCS#11 module a command-line tool are included.
 .
 This package contains the command-line tool.

Package: ykcs11
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}, libykpiv1 (= ${binary:Version})
Description: PKCS#11 module for the YubiKey PIV applet
 The Yubico PIV tool is used for interacting with the Personal
 Identity Verification Card (PIV) application on a YubiKey.  With it
 you may generate keys on the device, import keys and certificates,
 create certificate requests, and other operations. A shared library,
 a PKCS#11 module a command-line tool are included.
 .
 This package contains the PKCS#11 module.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel --with autoreconf --builddirectory=build

override_dh_install:
	chrpath -d $(CURDIR)/debian/tmp/usr/bin/*
	chrpath -d $(CURDIR)/debian/tmp/usr/lib/*/libykpiv.so.*
	chrpath -d $(CURDIR)/debian/tmp/usr/lib/*/libykcs11.so.*
	find debian/tmp -name \*.la -delete
	find debian/tmp -name libykcs11.a -delete
	find debian/tmp -name ykcs11-version.h -delete
	dh_install --fail-missing

override_dh_auto_configure:
	dh_auto_configure -- --disable-silent-rules

## yubico-piv-tool 1.5.0

=== debian/changelog ===
yubico-piv-tool (1.5.0-1) unstable; urgency=medium

  * New upstream version.  Closes: #810284.
    - Replace libssl1.0 with libssl1.1.  Closes: #859838.
    - Depend on check.
  * Use https URLs in debian/copyright.
  * Update Standards-Version from 3.9.8 to 4.1.4.
    - Priority optional instead of extra.
  * Use compat level 11.
    - Drop no longer needed --parallel.
    - Drop no longer needed --with autoreconf.
    - Drop no longer needed --disable-silent-rules.
    - Drop no longer needed --builddirectory.
    - Drop no longer needed dh-autoreconf.

 -- Simon Josefsson <simon@josefsson.org>  Mon, 11 Jun 2018 21:56:06 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: yubico-piv-tool
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
 Uploaders: Simon Josefsson <simon@josefsson.org>, Klas Lindfors <klas@yubico.com>, Dain Nilsson <dain@yubico.com>, Alessio Di Mauro <alessio@yubico.com>
 Section: utils
-Priority: extra
-Build-Depends: debhelper (>= 9), pkg-config, libpcsclite-dev, libssl1.0-dev | libssl-dev (<< 1.1.0~), gengetopt, help2man, dh-autoreconf, chrpath
-Standards-Version: 3.9.8
+Priority: optional
+Build-Depends: debhelper (>= 11), pkg-config, libpcsclite-dev, check, libssl-dev, gengetopt, help2man, chrpath
+Standards-Version: 4.1.4
 Homepage: https://developers.yubico.com/yubico-piv-tool/
 Vcs-Browser: https://github.com/Yubico/yubico-piv-tool-dpkg
 Vcs-Git: https://github.com/Yubico/yubico-piv-tool-dpkg.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_install:
	chrpath -d $(CURDIR)/debian/tmp/usr/bin/*
	chrpath -d $(CURDIR)/debian/tmp/usr/lib/*/libykpiv.so.*
	chrpath -d $(CURDIR)/debian/tmp/usr/lib/*/libykcs11.so.*
	find debian/tmp -name \*.la -delete
	find debian/tmp -name libykcs11.a -delete
	find debian/tmp -name ykcs11-version.h -delete
	dh_install --fail-missing

## yubico-piv-tool 1.6.2

=== debian/changelog ===
yubico-piv-tool (1.6.2-1) unstable; urgency=high

  * New upstream version 1.6.2.
  * Update Standards-Version from 4.2.0 to 4.2.1.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 25 Sep 2018 11:40:12 +0200

yubico-piv-tool (1.6.1-1) unstable; urgency=high

  [ Nicolas Braud-Santoni ]
  * New upstream version 1.6.1 (2018-08-17)
    Fixes a potential buffer overflow (CVE-2018-14779, CVE-2018-14780)
    Closes: #906128

  * Update upstream signing keys & move them to debian/upstream
  * debian/copyright: Solve duplicate license in DEP-5 format
  * debian/control
    + Sort the Uploaders list.
    + Add myself to Uploaders.
    + Declare compliance with policy 4.2.0.
      No change required

  [ Simon Josefsson ]
  * Update URLs to reflect move of dpkg git to salsa.

 -- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Sun, 19 Aug 2018 12:38:11 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,18 @@
 Source: yubico-piv-tool
 Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
-Uploaders: Simon Josefsson <simon@josefsson.org>, Klas Lindfors <klas@yubico.com>, Dain Nilsson <dain@yubico.com>, Alessio Di Mauro <alessio@yubico.com>
+Uploaders:
+ Nicolas Braud-Santoni <nicolas@braud-santoni.eu>,
+ Alessio Di Mauro <alessio@yubico.com>,
+ Simon Josefsson <simon@josefsson.org>,
+ Klas Lindfors <klas@yubico.com>,
+ Dain Nilsson <dain@yubico.com>
 Section: utils
 Priority: optional
 Build-Depends: debhelper (>= 11), pkg-config, libpcsclite-dev, check, libssl-dev, gengetopt, help2man, chrpath
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Homepage: https://developers.yubico.com/yubico-piv-tool/
-Vcs-Browser: https://github.com/Yubico/yubico-piv-tool-dpkg
-Vcs-Git: https://github.com/Yubico/yubico-piv-tool-dpkg.git
+Vcs-Browser: https://salsa.debian.org/auth-team/yubico-piv-tool
+Vcs-Git: https://salsa.debian.org/auth-team/yubico-piv-tool.git
 
 Package: libykpiv1
 Architecture: any

## yubico-piv-tool 1.7.0

=== debian/changelog ===
yubico-piv-tool (1.7.0-1) unstable; urgency=high (security fixes)

  [ Nicolas Braud-Santoni ]
  * New upstream version 1.7.0
    + Security fixes. (Closes: #926551)
    + ykcs11: Fix ECDSA signatures.
    + Documentation fixes.
    + libykpiv1: Update symbols file, add Build-Depends-Package metadata

  * debian/upstream: Update keyring and its generation script

  * debian/control
    + Update Uploader's email address
    + Bump Standards-Version to 4.3.0
      No change required.

  * Switch to debhelper 12
  * debian/rules
    + Avoid unnecessary override_dh_install
    + Don't set rpath at build-time, rather than overriding
    + Replace `dh_install --fail-missing` with `dh_missing`

  * ykcs11: Add Lintian overrides for PKCS#11 quirks
  * libykpiv-dev: Do not ship pkgconfig metadata for ykcs11
    + YKCS11 is a PKCS#11 provider
    + This would be the wrong package for it anyhow.

  [ Simon Josefsson ]
  * Drop myself from Uploaders.

 -- Nicolas Braud-Santoni <nicoo@debian.org>  Sat, 06 Apr 2019 22:35:22 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: yubico-piv-tool
 Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
 Uploaders:
- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>,
+ Nicolas Braud-Santoni <nicoo@debian.org>,
  Alessio Di Mauro <alessio@yubico.com>,
- Simon Josefsson <simon@josefsson.org>,
  Klas Lindfors <klas@yubico.com>,
  Dain Nilsson <dain@yubico.com>
 Section: utils
 Priority: optional
-Build-Depends: debhelper (>= 11), pkg-config, libpcsclite-dev, check, libssl-dev, gengetopt, help2man, chrpath
-Standards-Version: 4.2.1
+Build-Depends: debhelper-compat (= 12), pkg-config, libpcsclite-dev, check, libssl-dev, gengetopt, help2man
+Standards-Version: 4.3.0
 Homepage: https://developers.yubico.com/yubico-piv-tool/
 Vcs-Browser: https://salsa.debian.org/auth-team/yubico-piv-tool
 Vcs-Git: https://salsa.debian.org/auth-team/yubico-piv-tool.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --disable-rpath

override_dh_missing:
	dh_missing --fail-missing

## yubico-piv-tool 2.0.0

=== debian/changelog ===
yubico-piv-tool (2.0.0-2) unstable; urgency=medium

  * debian/rules: Compile and link with -pthread
  * debian/control: Add Rules-Requires-Root: no
  * Add CI using salsa-ci-team's pipeline
  * Update authorship information

 -- nicoo <nicoo@debian.org>  Sun, 16 Feb 2020 11:12:49 +0100

yubico-piv-tool (2.0.0-1) unstable; urgency=medium

  * New upstream version 2.0.0 (2020-01-29)
    + libykpiv1: Update symbols file
    + yubico-piv-tool: Patch typo
    + debian/upstream: Update signing keyring

  * Rename packaging branch to debian/sid (formerly master)
  * Declare compliance with policy v4.5.0.
    No change required.

 -- Nicolas Braud-Santoni <nicoo@debian.org>  Wed, 12 Feb 2020 13:18:52 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,18 @@
 Source: yubico-piv-tool
 Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
 Uploaders:
- Nicolas Braud-Santoni <nicoo@debian.org>,
+ nicoo <nicoo@debian.org>,
  Alessio Di Mauro <alessio@yubico.com>,
  Klas Lindfors <klas@yubico.com>,
  Dain Nilsson <dain@yubico.com>
 Section: utils
 Priority: optional
 Build-Depends: debhelper-compat (= 12), pkg-config, libpcsclite-dev, check, libssl-dev, gengetopt, help2man
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Homepage: https://developers.yubico.com/yubico-piv-tool/
 Vcs-Browser: https://salsa.debian.org/auth-team/yubico-piv-tool
 Vcs-Git: https://salsa.debian.org/auth-team/yubico-piv-tool.git
+Rules-Requires-Root: no
 
 Package: libykpiv1
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,8 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_CFLAGS_MAINT_APPEND = -pthread
+export DEB_LDFLAGS_MAINT_APPEND = -pthread
 
 %:
 	dh $@

## yubico-piv-tool 2.2.0

=== debian/changelog ===
yubico-piv-tool (2.2.0-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Julien Cristau <jcristau@debian.org>  Thu, 18 Feb 2021 10:09:36 +0100

yubico-piv-tool (2.2.0-1) unstable; urgency=medium

  * New upstream version 2.2.0 (2021-01-20)
    + ypiv Fixed memory leaks and error handling
    + ykcs11
      - Updated Cryptoki version
      - Support for destroying ECDH derived keys
      - Improved handling of PIN after device re-connection

  * Make the build deterministic by setting CMAKE_BUILD_RPATH_USE_ORIGIN

  * d/copyright: Fix syntax issue in Upstream-Contact
  * d/control: Declare compliance with policy v4.5.1 (no change needed)
  * libykpiv2: Update symbols file
  * yubico-piv-tool: Put useful description in manpage

 -- nicoo <nicoo@debian.org>  Sun, 31 Jan 2021 16:58:55 +0100

yubico-piv-tool (2.1.1-3) unstable; urgency=high (RC and security)

  * d/control: Fix a syntax error in the Uploaders field
    Closes: #975689

 -- nicoo <nicoo@debian.org>  Thu, 26 Nov 2020 05:41:48 +0100

yubico-piv-tool (2.1.1-2) unstable; urgency=high (security)

  * Source-only reupload for migration to testing.
  * d/control: Add Multi-Arch fields on all binary packages

 -- nicoo <nicoo@debian.org>  Tue, 24 Nov 2020 18:20:25 +0100

yubico-piv-tool (2.1.1-1) unstable; urgency=high (security)

  * New upstream version 2.1.1 (2020-07-20)
    + Security fix (YSA-2020-02, CVE-2020-13132)
    + Fixed potential memory leaks
    + Improved error handling
    + Support setting debug output at runtime
    + Build system switched to CMake

  * libykpiv-dev: Install headers to /usr/include/$(DEB_HOST_MULTIARCH)/
  * Update symbols file and bump SO_VERSION.
    Upstream broke ABI compatibility without changing the SONAME, as the symbol
    versioning scheme changed.  This presumably happened with the CMake switch.

  * d/copyright: Set Upstream-Contact to Yubico's OSS maintainers role
  * d/changelog: Amend to update maintainer's name and email address
  * d/watch: Declare compatibility with version 4.
    No change required.
  * d/control: Switch to debhelper 13

 -- nicoo <nicoo@debian.org>  Mon, 23 Nov 2020 22:26:41 +0100

=== debian/control ===
--- 
+++ 
@@ -1,27 +1,34 @@
 Source: yubico-piv-tool
 Maintainer: Debian Authentication Maintainers <pkg-auth-maintainers@lists.alioth.debian.org>
 Uploaders:
- nicoo <nicoo@debian.org>,
- Alessio Di Mauro <alessio@yubico.com>,
- Klas Lindfors <klas@yubico.com>,
- Dain Nilsson <dain@yubico.com>
+	Alessio Di Mauro <alessio@yubico.com>,
+	Dain Nilsson <dain@yubico.com>,
+	Klas Lindfors <klas@yubico.com>,
+	nicoo <nicoo@debian.org>
 Section: utils
 Priority: optional
-Build-Depends: debhelper-compat (= 12), pkg-config, libpcsclite-dev, check, libssl-dev, gengetopt, help2man
-Standards-Version: 4.5.0
+Build-Depends:
+	debhelper-compat (= 13),
+  cmake,
+	pkg-config,
+	check,
+	gengetopt,
+	help2man,
+	libpcsclite-dev,
+	libssl-dev,
+Standards-Version: 4.5.1
 Homepage: https://developers.yubico.com/yubico-piv-tool/
 Vcs-Browser: https://salsa.debian.org/auth-team/yubico-piv-tool
 Vcs-Git: https://salsa.debian.org/auth-team/yubico-piv-tool.git
 Rules-Requires-Root: no
 
-Package: libykpiv1
+Package: libykpiv2
 Architecture: any
 Section: libs
+Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: pcscd
-Replaces: libykpiv0
-Conflicts: libykpiv0
 Description: Library for communication with the YubiKey PIV smartcard
  The Yubico PIV tool is used for interacting with the Personal
  Identity Verification Card (PIV) application on a YubiKey.  With it
@@ -35,7 +42,8 @@
 Package: libykpiv-dev
 Architecture: any
 Section: libdevel
-Depends: ${shlibs:Depends}, ${misc:Depends}, libykpiv1 (= ${binary:Version})
+Multi-Arch: same
+Depends: ${shlibs:Depends}, ${misc:Depends}, libykpiv2 (= ${binary:Version})
 Description: Development files for the YubiKey PIV Library
  The Yubico PIV tool is used for interacting with the Personal
  Identity Verification Card (PIV) application on a YubiKey.  With it
@@ -47,6 +55,7 @@
 
 Package: yubico-piv-tool
 Architecture: any
+Multi-Arch: no
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Command line tool for the YubiKey PIV applet
  The Yubico PIV tool is used for interacting with the Personal
@@ -60,7 +69,8 @@
 Package: ykcs11
 Architecture: any
 Section: libs
-Depends: ${shlibs:Depends}, ${misc:Depends}, libykpiv1 (= ${binary:Version})
+Multi-Arch: no
+Depends: ${shlibs:Depends}, ${misc:Depends}, libykpiv2 (= ${binary:Version})
 Description: PKCS#11 module for the YubiKey PIV applet
  The Yubico PIV tool is used for interacting with the Personal
  Identity Verification Card (PIV) application on a YubiKey.  With it
